/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI;

namespace IPluginHeartbeatTask_Example
{
    /* Class Declaration: Inherit from Plugin, expose IPluginHeartbeatTask */
    public class IPluginHeartbeatTask_Example : Plugin, IPluginHeartbeatTask
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginHeartbeatTask_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginHeartbeatTask Members

        public void HeartbeatTask()
        {
            /* initialize the heartbeat count variable */
            int nHeartbeatHits = 0;
            try
            {
                /* lookup the stored value for the heartbeat count in the plugin's key/value table */
                nHeartbeatHits = Convert.ToInt32(api.Database.GetKeyValue("nHeartbeatHits"));
            }
            /* If there is no entry or it can't be converted to an integer, just ignore and use
             * the zero value set at initialization */
            catch (Exception) { }
            /* heartbeat just ran, so increment the count */
            nHeartbeatHits ++;
            /* add a message to the admin notifications informing the admin of the heartbeat count */
            api.Notifications.AddAdminNotification("Heartbeat Count",string.Format("Heartbeat has run {0} times since this plugin was installed.",nHeartbeatHits));
            /* save the new value to the database */
            api.Database.SetKeyValue("nHeartbeatHits",nHeartbeatHits.ToString());
        }

        #endregion
    }
}

